﻿/*
 * 數論類別庫-最大公因數
 * 2/26/2009
 */

using System;

namespace NumberTheoryLibrary
{
    public class GCD
    {
        /* 利用Euclid演算法找出兩數之最大公因數
         * 9/25/2008
         */
        public static int Euclid(int x, int y)
        {
            if (x < y) // x 必須較大, 否則需交換
            {
                swap(ref x, ref y);
            }
            int remainder;
            while (y != 0)
            {
                remainder = x % y;
                x = y;
                y = remainder;
            }
            return x;
        }

        private static void swap(ref int x, ref int y)
        {
            int temp = x;
            x = y;
            y = temp;
        }
    }
}
